-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}
M.type = "auxilliary"
M.relevantDevice = nil

local min = math.min
local max = math.max
local abs = math.abs
local leftWheel = nil
local rightWheel = nil


local function updateGFX(dt)
  local brakeR = min(max(electrics.values.brake_r, 0), 1)
  local brakeL = min(max(electrics.values.brake_l, 0), 1)
  rightWheel.desiredBrakingTorque = 2*(rightWheel.brakeTorque * brakeR)
  leftWheel.desiredBrakingTorque = 2*(leftWheel.brakeTorque * brakeL)

  

  
  if electrics.values.brake == 1 then
    electrics.values.brake_r =  1-(max(-electrics.values.steering_input/2, 0))
    electrics.values.brake_l = 1-(max(electrics.values.steering_input/2, 0))
  else
   electrics.values.brake_r = (max(electrics.values.steering_input, 0))--* (max(electrics.values.throttle, 0.7))
   electrics.values.brake_l = (max(-electrics.values.steering_input, 0))-- * (max(electrics.values.throttle, 0.7))
  end  
end 


local function init(jbeamData)
  electrics.values.brake_l = 0
  electrics.values.brake_r = 0
  electrics.values.brake_combined = 0

  
  for _,wd in pairs(wheels.wheels) do
    if wd.name == "RR" then rightWheel = wd end
    if wd.name == "RL" then leftWheel = wd end

  end
end

M.init = init
M.updateGFX = updateGFX
M.update = update

return M